;+
; NAME:
;	TRACE_SSWHERE_EVENT
; PURPOSE:
;	Event processor called by widget created by TRACE_SSWHERE
; CATEGORY:
; CALLING SEQUENCE:
;	Only called by TRACE_SSWHERE
; INPUTS:
; OPTIONAL INPUT PARAMETERS:
; KEYWORD PARAMETERS:
; OUTPUTS:
; OPTIONAL OUTPUT PARAMETERS:
; COMMON BLOCKS:
; SIDE EFFECTS:
; RESTRICTIONS:
; PROCEDURE:
;	Responds to interrupts and sets values. 
; MODIFICATION HISTORY:
;	RDB     Sep-98  Written
;
;-
pro	trace_sswhere_event,evnt

common obs_tbl,bchans,hchans,schans,wchans,gchans,ggch,gghilo
common obs_cm2,bchan_vec,hchan_vec,schan_vec,wchan_vec,gchan_vec, $
		durn,batse,exact,fem,fov,sfm,quit
common obs_btnx,b0a,b0b,b1,b2,b2a,b2b,b2c,b3,b4,b5,duration
common obs_btn,timwgt,timwgt2,expmin,expmax,txtwgt,listwgt
common obs_times,time1,time2,texp1,texp2,wdebug
common obs_plot_msgs,err_mess,warn_mess

common obs_index,index, dsets

;
;	Event handler for trace_sswhere
; 


type = tag_names(evnt,/structure)
;;widget_control,evnt.id,get_value=value        ;menu name
widget_control,evnt.id,get_uvalue=uvalue      ;button name

if wdebug then begin
  help,/st,evnt
  print,'Type = ',type
;  print,'Value= ',value
endif

if type eq 'WIDGET_LIST' then begin
;   help,/st,evnt
case uvalue of
	'trace channel': begin
		print,'** TRACE channel',evnt.index
		wchan_vec(evnt.index) = (1-wchan_vec(evnt.index))
		widget_control,evnt.id,set_list_select=evnt.index
		help,wchans,wchan_vec
	   end
	'trace fov': begin
		print,'** TRACE FOV',evnt.index
                bchan_vec(evnt.index) = (1-bchan_vec(evnt.index))
		widget_control,evnt.id,set_list_select=evnt.index
		help,bchans,bchan_vec
	   end

	 else: print,'Unknown list'
endcase

if wdebug then begin
   print,wchan_vec
   print,bchan_vec
endif

return
endif


if type eq 'WIDGET_DROPLIST' then begin
;   help,/st,evnt
   case uvalue of
         'AEC': begin
	       print,'AEC'
;;	       ;print,evnt.index
;;	       ;gchan_vec(0)=gchan_vec(0) + evnt.index
;;	       gchan_vec(1) = evnt.index
 	    end

	 else: print,'Unknown droplist'
   endcase
   
return
endif

widget_control,evnt.id,get_value=value        ;menu name

if type eq 'WIDGET_SLIDER' then begin
  durn = evnt.value
;  print,'Duration =',durn
   time2 = fmt_tim(addtime(time1,delt=durn))
   widget_control,timwgt2,set_value=time2
endif

if type eq 'WIDGET_TEXT_CH' then begin
;   print,timwgt,timwgt2
print,expmin,expmax
   case evnt.id of
;	timwgt: begin
;	      print,'** New Start Time = ',value
;	      time1 = value(0)
;	   end
;	timwgt2: begin
;	      print,'** New Stop Time = ',value
;	      time2 = value(0)
;	   end

	expmin: begin
	      print,'** New Min. Exposure = ',value
	      texp1 = strtrim(value(0),2)
	   end
	expmax: begin
	      print,'** New Max. Exposure = ',value
	      texp2 = strtrim(value(0),2)
	   end
	else: print,'Unknown text window'
	else: 
   endcase

help,texp1,texp2
   return

endif


if type eq 'WIDGET_BUTTON' then begin
  
  case uvalue of

    'TRACE Channels': begin
          print,'TRACE Channels',evnt.select
;	print,hchans
	hchan_vec(where(hchans eq value)) = evnt.select
	print,hchan_vec
       endif

    'Image Dimension': begin
          print,'TRACE Image Dimension',evnt.select
	print,schans
	schan_vec = schan_vec*0
	schan_vec(where(schans eq value)) = evnt.select
	print,schan_vec
       endif

    'Reset': begin
          trace_sswhere_reset
       endif

;;;		reset all values to initial ones
;;;???	start and stop times
;;
;;;		reset wavelengths
;;         for jj = 0,n_elements(hchans)-1 do begin
;;            widget_control,b4(jj),set_button=0 & hchan_vec(jj)=0
;;         endfor
;;;		reset dimensions
;;         for jj = 0,n_elements(schans)-1 do begin
;;            widget_control,b2(jj),set_button=0 & schan_vec(jj)=0
;;         endfor
;;;		reset min., max. exposure
;;	texp1 = '' & texp2 = ''
;;       endif

    'show selection': begin

if max(hchan_vec) gt 0 then begin
   lim_wave = strtrim(hchans(where(hchan_vec gt 0)),2)
endif else lim_wave = -1
print,'lim_wave: ',lim_wave

if max(schan_vec) gt 0 then begin
   lim_naxis1 = strmid(schans(where(schan_vec gt 0)),7,4)
endif else lim_naxis1 = -1
print,'lim_naxis1:',lim_naxis1

help,texp1,texp2
lim_dur = texp1
if texp2 ne '' then lim_dur = [texp1,texp2]

ssx = ''
if lim_naxis1(0) ne -1 then ssx = [ssx,gt2exe('naxis1>='+arr2str(lim_naxis1,','),/noss)]
if lim_wave(0) ne -1 then ssx = [ssx,gt2exe('wave_len='+arr2str(lim_wave,','),/noss)]
if lim_dur(0) ne '' then ssx = [ssx,gt2exe('sht_mdur>='+arr2str(lim_dur,'~'),/noss)]
if n_elements(ssx) gt 1 then ssx = 'dd=where(('+arr2str(ssx(1:*),') and (')+'))'
result = execute(ssx)
help,dd,result,index
;;	print,ssx

;	save resulting vector to common
if n_elements(dd) gt 0 then ddx = dd $
  else ddx = indgen(n_elements(index))
;;dsets = index(ddx).image_ss
dsets = ddx

frame_list = trace_list_index(index(ddx))
;;help,frame_list
WIDGET_CONTROL,listwgt,set_value=frame_list

;	remember not to count banner record in no. of images
mess1 = strtrim(string(n_elements(frame_list)-1),2)+' images selected'
message = [mess1,'',ssx]
WIDGET_CONTROL,txtwgt,set_value= message

	  
       end


    'Exit':  begin
	  quit=0L
	  widget_control,/destroy,evnt.top
       end

			
    else:  print,'** Unknown Button **'
  endcase
endif


return

end
